Subject: Re: bug#49931: 28.0.50; `choose-completion' submits incorrect string when minibuffer content changes after creation of the *Completions* buffer

From: Eli Zaretskii <[email-masked]>
Date: Sun, 08 Aug 2021 10:14:22 +0300

> Date: Sun, 8 Aug 2021 09:02:31 +0200 (CEST)
> From: Visuwesh <[email-masked]>
> Cc: [email-masked]
> 
> Yes, I expected Emacs to ignore 'a'.
> 
> > Why?
> 
> The name `choose-completion' leads one to think that the candidate
> will be chosen regardless of whatever is in the minibuffer but that is
> not the case.  I think the current behaviour is not intuitive.
> 
> > What you type after TAB is used to narrow the list of candidates when
> > you type the next TAB, or continue typing after the first TAB
> > completed some of the name for you. This is the intended behavior.
> 
> I do understand how the standard behaviour is supposed to be.  But I
> believe the current behaviour is unnatural.  When I am offered
> clickable text in a buffer which are advertised to complete the
> command when clicked, I expect that to happen.  In my case, the text
> visible in the *Completions* buffer did not have an extra 'a' but upon
> choosing, it did.  I think this is misleading.

I think your expectations are incorrect, because they are based on
assumptions that are generally false in Emacs.  In particular,
depending on the context of the completion, typing more stuff after
selecting a candidate is what is actually needed, so ignoring that
would break valid use cases.

Therefore I think we will have to agree to disagree on this one.  I
see no bug in the behavior you described.  If it looks misleading to
you, you will have to get used to it.